#Include <Constants.au3>
#include <WinAPI.au3>
#include <WinAPIEx.au3>



Local Const $TETRIS_BACKGROUND_FILLCOLORS[3] = [0xFFEEDD, 0xC7D8E9, 0xD0E1F2]
Local Const $TETRIS_STAGE_X = 20
Local Const $TETRIS_STAGE_Y = 20
Local Const $TETRIS_STAGE_WIDTH = 249
Local Const $TETRIS_STAGE_HEIGHT = 441
Local Const $TETRIS_STAGE_BORDERSIZE = 4
Local Const $TETRIS_STAGE_BORDERCOLOR = 0xAA8877
Local Const $TETRIS_STAGE_FILLCOLORS[3] = [0xEACFBE, 0xC7D8E9, 0xD0E1F2]
Local Const $TETRIS_BLOCK_FILLCOLORS[7][8] = _
		[[0x000033, 0x00007F, 0x0000CC, 0x0000D8, 0x4C4CCC, 0x6666FF, 0x3333FF, 0x0000FF], _
		[0x001133, 0x0059A5, 0x0066CC, 0x0066D8, 0x3399FF, 0x3399FF, 0x0C72FF, 0x0066FF], _
		[0x330000, 0x7F0000, 0xCC0000, 0xD80000, 0xCC4C4C, 0xFF6666, 0xFF4C4C, 0xFF0000], _
		[0x330011, 0x7F0055, 0xCC0099, 0xD800A5, 0xCC4C9D, 0xFF66CC, 0xFF4CCC, 0xFF00CC], _
		[0x331100, 0xA57726, 0xCC9933, 0xE5B24C, 0xBFCC7F, 0xFFFF99, 0xFFE57F, 0xFFCC66], _
		[0x003300, 0x007F00, 0x00CC00, 0x00D800, 0x4CCC4C, 0x66FF66, 0x4CFF4C, 0x00FF00], _
		[0x003333, 0x00A5CC, 0x00CCFF, 0x00E5FF, 0x72CCCC, 0x99FFFF, 0x4CFFFF, 0x00FFFF]]
Local Const $TETRIS_PROMPTAREA_X = 280
Local Const $TETRIS_PROMPTAREA_Y = 20
Local Const $TETRIS_PROMPTAREA_WIDTH = 201
Local Const $TETRIS_PROMPTAREA_HEIGHT = 105
Local Const $TETRIS_PROMPTAREA_BORDERSIZE = 4	
Local Const $TETRIS_PROMPTAREA_BORDERCOLOR = 0xAA8877
Local Const $TETRIS_PROMPTAREA_BACKGROUNDCOLOR = 0xFFEEDD
Local Const $TETRIS_SCOREAREA_X = 280
Local Const $TETRIS_SCOREAREA_Y = 135
Local Const $TETRIS_SCOREAREA_WIDTH = 201
Local Const $TETRIS_SCOREAREA_HEIGHT = 136
Local Const $TETRIS_SCOREAREA_BORDERSIZE = 4	
Local Const $TETRIS_SCOREAREA_BORDERCOLOR = 0xAA8877
Local Const $TETRIS_SCOREAREA_BACKGROUNDCOLOR = 0xFFEEDD
Local Const $TETRIS_LOGOAREA_X = 280
Local Const $TETRIS_LOGOAREA_Y = 281
Local Const $TETRIS_LOGOAREA_WIDTH = 201
Local Const $TETRIS_LOGOAREA_HEIGHT = 180
Local Const $TETRIS_LOGOAREA_BORDERSIZE = 4	
Local Const $TETRIS_LOGOAREA_BORDERCOLOR = 0xAA8877
Local Const $TETRIS_LOGOAREA_BACKGROUNDCOLOR = 0xFFEEDD
Local Const $TETRIS_LOGO_FILENAME = @TempDir & "\Tetris_Logo.bmp"
Local Const $TETRIS_LOGO_WIDTH = 128
Local Const $TETRIS_LOGO_HEIGHT = 128
Local Const $TETRIS_HELP_FILENAME = @TempDir & "\Tetris_Help.bmp"

Local $aBackgroundObjects[3] = [False, False, False]
Local $nGameBackgroundWidth = 0
Local $nGameBackgroundHeight = 0
Local $aBlockObjects[7] = [False, False, False, False, False, False, False]


Func DrawTetrisGraphics($hWnd, $aLayout, $aPosition, $iIndex, $iShapeX, $iShapeY, $iShapeIndex, _
			$iSeconds, $iRowCount, $iScore, $fGameOver)
	Local $hDesktopWnd, $hDesktopDC, $hCompatibleDC, $hBitmap, $hOldBitmap, $hDC, _
			$hBlackDC, $hBlackBitmap, $hOldBlackBitmap
	_WinAPI_RedrawWindow($hWnd, 0, 0, $RDW_UPDATENOW)
	DrawGameBackground($hWnd)
	$hDesktopWnd = _WinAPI_GetDesktopWindow()
	$hDesktopDC = _WinAPI_GetDC($hDesktopWnd)
	$hCompatibleDC = _WinAPI_CreateCompatibleDC($hDesktopDC)
	$hBitmap = _WinAPI_CreateCompatibleBitmap($hDesktopDC, _
			$nGameBackgroundWidth, $nGameBackgroundHeight)
	$hOldBitmap = _WinAPI_SelectObject($hCompatibleDC, $hBitmap)
	If IsBool($aBackgroundObjects[0]) = 0 Then
		_WinAPI_BitBlt($hCompatibleDC, 0, 0, $nGameBackgroundWidth, $nGameBackgroundHeight, _
				$aBackgroundObjects[0], 0, 0, $SRCCOPY)
	EndIf
	DrawTetrisLayout($hCompatibleDC, $aLayout, $aPosition, $iIndex, $iShapeX, $iShapeY)
	DrawPromptAreaShape($hCompatibleDC, $iShapeIndex)
	DrawScoreText($hCompatibleDC, $iSeconds, $iRowCount, $iScore)
	$hDC = _WinAPI_GetDC($hWnd)
	If $fGameOver = False Then
		_WinAPI_BitBlt($hDC, 0, 0, $nGameBackgroundWidth, $nGameBackgroundHeight, _
				$hCompatibleDC, 0, 0, $SRCCOPY)
	Else
		$hBlackDC = _WinAPI_CreateCompatibleDC($hDesktopDC)
		$hBlackBitmap = _WinAPI_CreateCompatibleBitmap($hDesktopDC, _
				$nGameBackgroundWidth, $nGameBackgroundHeight)
		$hOldBlackBitmap = _WinAPI_SelectObject($hBlackDC, $hBlackBitmap)
		DrawBackground($hBlackDC, 0, 0, $nGameBackgroundWidth, $nGameBackgroundHeight, 0x808080)
		_WinAPI_BitBlt($hDC, 0, 0, $nGameBackgroundWidth, $nGameBackgroundHeight, _
				$hBlackDC, 0, 0, $SRCCOPY)
		_WinAPI_AlphaBlend($hDC, 0, 0, $nGameBackgroundWidth, $nGameBackgroundHeight, _
				$hCompatibleDC, 0, 0, $nGameBackgroundWidth, $nGameBackgroundHeight, _
				192)
		$hBlackBitmap = _WinAPI_SelectObject($hBlackDC, $hOldBlackBitmap)
		_WinAPI_DeleteObject($hBlackBitmap)
		_WinAPI_DeleteDC($hBlackDC)
	EndIf
	$hBitmap = _WinAPI_SelectObject($hCompatibleDC, $hOldBitmap)
	_WinAPI_DeleteObject($hBitmap)
	_WinAPI_DeleteDC($hCompatibleDC)
	_WinAPI_ReleaseDC($hWnd, $hDC)
	_WinAPI_ReleaseDC($hDesktopWnd, $hDesktopDC)
	_WinAPI_RedrawWindow($hWnd, 0, 0, $RDW_VALIDATE)
EndFunc


Func DrawGameBackground($hWnd)
	Local $tRect, $nWidth, $nHeight, $hDesktopWnd, $hDesktopDC, $hCompatibleDC, $hBitmap, $hOldBitmap, _
			$hLogoDC, $hLogoBitmap, $hOldLogoBitmap, $nLogoX, $nLogoY
	If IsBool($aBackgroundObjects[0]) = 0 Then Return
	$tRect = _WinAPI_GetClientRect($hWnd)
	$nWidth = DllStructGetData($tRect, "Right") - DllStructGetData($tRect, "Left")
	$nHeight = DllStructGetData($tRect, "Bottom") - DllStructGetData($tRect, "Top")
	$hDesktopWnd = _WinAPI_GetDesktopWindow()
	$hDesktopDC = _WinAPI_GetDC($hDesktopWnd)
	$hCompatibleDC = _WinAPI_CreateCompatibleDC($hDesktopDC)
	$hBitmap = _WinAPI_CreateCompatibleBitmap($hDesktopDC, $nWidth, $nHeight)
	$hOldBitmap = _WinAPI_SelectObject($hCompatibleDC, $hBitmap)
	_WinAPI_SetBkMode($hCompatibleDC, $TRANSPARENT)
	FillBackground($hCompatibleDC, 0, 0, $nWidth, $nHeight, $TETRIS_BACKGROUND_FILLCOLORS)
	DrawBackground($hCompatibleDC, $TETRIS_STAGE_X, $TETRIS_STAGE_Y, _
			$TETRIS_STAGE_WIDTH, $TETRIS_STAGE_HEIGHT, $TETRIS_STAGE_BORDERCOLOR)
	FillBackground($hCompatibleDC, _
			$TETRIS_STAGE_X + $TETRIS_STAGE_BORDERSIZE, _
			$TETRIS_STAGE_Y + $TETRIS_STAGE_BORDERSIZE, _
			$TETRIS_STAGE_WIDTH - $TETRIS_STAGE_BORDERSIZE * 2, _
			$TETRIS_STAGE_HEIGHT - $TETRIS_STAGE_BORDERSIZE * 2, _
			$TETRIS_STAGE_FILLCOLORS)
	DrawBackground($hCompatibleDC, $TETRIS_PROMPTAREA_X, $TETRIS_PROMPTAREA_Y, _
			$TETRIS_PROMPTAREA_WIDTH, $TETRIS_PROMPTAREA_HEIGHT, $TETRIS_PROMPTAREA_BORDERCOLOR)
	DrawBackground($hCompatibleDC, _
			$TETRIS_PROMPTAREA_X + $TETRIS_PROMPTAREA_BORDERSIZE, _
			$TETRIS_PROMPTAREA_Y + $TETRIS_PROMPTAREA_BORDERSIZE, _
			$TETRIS_PROMPTAREA_WIDTH - $TETRIS_PROMPTAREA_BORDERSIZE * 2, _
			$TETRIS_PROMPTAREA_HEIGHT - $TETRIS_PROMPTAREA_BORDERSIZE * 2, _
			$TETRIS_PROMPTAREA_BACKGROUNDCOLOR)
	DrawBackground($hCompatibleDC, $TETRIS_SCOREAREA_X, $TETRIS_SCOREAREA_Y, _
			$TETRIS_SCOREAREA_WIDTH, $TETRIS_SCOREAREA_HEIGHT, $TETRIS_SCOREAREA_BORDERCOLOR)
	DrawBackground($hCompatibleDC, _
			$TETRIS_SCOREAREA_X + $TETRIS_SCOREAREA_BORDERSIZE, _
			$TETRIS_SCOREAREA_Y + $TETRIS_SCOREAREA_BORDERSIZE, _
			$TETRIS_SCOREAREA_WIDTH - $TETRIS_SCOREAREA_BORDERSIZE * 2, _
			$TETRIS_SCOREAREA_HEIGHT - $TETRIS_SCOREAREA_BORDERSIZE * 2, _
			$TETRIS_SCOREAREA_BACKGROUNDCOLOR)
	DrawBackground($hCompatibleDC, $TETRIS_LOGOAREA_X, $TETRIS_LOGOAREA_Y, _
			$TETRIS_LOGOAREA_WIDTH, $TETRIS_LOGOAREA_HEIGHT, $TETRIS_LOGOAREA_BORDERCOLOR)
	DrawBackground($hCompatibleDC, _
			$TETRIS_LOGOAREA_X + $TETRIS_LOGOAREA_BORDERSIZE, _
			$TETRIS_LOGOAREA_Y + $TETRIS_LOGOAREA_BORDERSIZE, _
			$TETRIS_LOGOAREA_WIDTH - $TETRIS_LOGOAREA_BORDERSIZE * 2, _
			$TETRIS_LOGOAREA_HEIGHT - $TETRIS_LOGOAREA_BORDERSIZE * 2, _
			$TETRIS_LOGOAREA_BACKGROUNDCOLOR)
	$hLogoDC = _WinAPI_CreateCompatibleDC($hDesktopDC)
	$hLogoBitmap = _WinAPI_LoadImage(0, $TETRIS_LOGO_FILENAME, $IMAGE_BITMAP, _
			0, 0, BitOR($LR_LOADFROMFILE, $LR_DEFAULTCOLOR, $LR_DEFAULTSIZE))
	$hOldLogoBitmap = _WinAPI_SelectObject($hLogoDC, $hLogoBitmap)
	_WinAPI_SetBkMode($hLogoDC, $TRANSPARENT)
	$nLogoX = $TETRIS_LOGOAREA_X + Round(($TETRIS_LOGOAREA_WIDTH - $TETRIS_LOGO_WIDTH) / 2)
	$nLogoY = $TETRIS_LOGOAREA_Y + Round(($TETRIS_LOGOAREA_HEIGHT - $TETRIS_LOGO_HEIGHT) / 2)
	_WinAPI_BitBlt($hCompatibleDC, $nLogoX, $nLogoY, $TETRIS_LOGO_WIDTH, $TETRIS_LOGO_HEIGHT, _
			$hLogoDC, 0, 0, $SRCCOPY)
	$hLogoBitmap = _WinAPI_SelectObject($hLogoDC, $hOldLogoBitmap)
	_WinAPI_DeleteObject($hLogoBitmap)
	_WinAPI_DeleteDC($hLogoDC)
	_WinAPI_ReleaseDC($hDesktopWnd, $hDesktopDC)
	$aBackgroundObjects[0] = $hCompatibleDC
	$aBackgroundObjects[1] = $hBitmap
	$aBackgroundObjects[2] = $hOldBitmap
	$nGameBackgroundWidth = $nWidth
	$nGameBackgroundHeight = $nHeight
EndFunc


Func DrawBackground($hDC, $nX, $nY, $nWidth, $nHeight, $iBackgroundColor)
	Local $hPen, $hOldPen, $hBrush, $hOldBrush, $sRect, $tRect
	$hPen = _WinAPI_CreatePen($PS_SOLID, 0, $iBackgroundColor)
	$hOldPen = _WinAPI_SelectObject($hDC, $hPen)
	$hBrush = _WinAPI_CreateSolidBrush($iBackgroundColor)
	$hOldBrush = _WinAPI_SelectObject($hDC, $hBrush)
	$sRect = "int left; int top; int right; int bottom"
	$tRect = DllStructCreate($sRect)
	DllStructSetData($tRect, "left", $nX)
	DllStructSetData($tRect, "top", $nY)
	DllStructSetData($tRect, "right", $nX + $nWidth)
	DllStructSetData($tRect, "bottom",  $nY + $nHeight)
	_WinAPI_Rectangle($hDC, $tRect)
	$hBrush = _WinAPI_SelectObject($hDC, $hOldBrush)
	_WinAPI_DeleteObject($hBrush)
	$hPen = _WinAPI_SelectObject($hDC, $hOldPen)
	_WinAPI_DeleteObject($hPen)
EndFunc


Func FillBackground($hDC, $nX, $nY, $nWidth, $nHeight, $aColors)
	Local $hBackgroundDC, $hBackgroundBitmap, $hOldBackgroundBitmap, $hPen, $hOldPen, _
			$hBrush, $hOldBrush, $sRect, $tRect, $i
	$hBackgroundDC = _WinAPI_CreateCompatibleDC($hDC)
	$hBackgroundBitmap = _WinAPI_CreateCompatibleBitmap($hDC, 6, 6)
	$hOldBackgroundBitmap = _WinAPI_SelectObject($hBackgroundDC, $hBackgroundBitmap)
	_WinAPI_SetBkMode($hBackgroundDC, $TRANSPARENT)
	$hPen = _WinAPI_CreatePen($PS_SOLID, 0, $aColors[0])
	$hOldPen = _WinAPI_SelectObject($hBackgroundDC, $hPen)
	$hBrush = _WinAPI_CreateSolidBrush($aColors[0])
	$hOldBrush = _WinAPI_SelectObject($hBackgroundDC, $hBrush)
	$sRect = "int left; int top; int right; int bottom"
	$tRect = DllStructCreate($sRect)
	DllStructSetData($tRect, "left", 0)
	DllStructSetData($tRect, "top", 0)
	DllStructSetData($tRect, "right", 6)
	DllStructSetData($tRect, "bottom", 6)
	_WinAPI_Rectangle($hBackgroundDC, $tRect)
	For $i = 0 To 5
		_WinAPI_SetPixel($hBackgroundDC, $i, 5 - $i, $aColors[1])
		If $i < 5 Then
			_WinAPI_SetPixel($hBackgroundDC, $i + 1, 5 - $i, $aColors[2])
		Else
			_WinAPI_SetPixel($hBackgroundDC, 0, 0, $aColors[2])
		EndIf
	Next
	$hBrush = _WinAPI_SelectObject($hBackgroundDC, $hOldBrush)
	_WinAPI_DeleteObject($hBrush)
	$hPen = _WinAPI_SelectObject($hBackgroundDC, $hOldPen)
	_WinAPI_DeleteObject($hPen)
	$hBrush = _WinAPI_CreatePatternBrush($hBackgroundBitmap)
	$hOldBrush = _WinAPI_SelectObject($hDC, $hBrush)
	_WinAPI_PatBlt($hDC, $nX, $nY, $nWidth, $nHeight, $PATCOPY)
	$hBrush = _WinAPI_SelectObject($hDC, $hOldBrush)
	_WinAPI_DeleteObject($hBrush)
	$hBackgroundBitmap = _WinAPI_SelectObject($hBackgroundDC, $hOldBackgroundBitmap)
	_WinAPI_DeleteObject($hBackgroundBitmap)
	_WinAPI_DeleteDC($hBackgroundDC)
EndFunc


Func DrawTetrisLayout($hDC, $aLayout, $aPosition, $iIndex, $iShapeX, $iShapeY)
	Local $i, $j, $nX, $nY
	For $i = 0 To 17
		For $j = 0 To 9
			If $aLayout[$i][$j] > 0 Then
				$nX = $TETRIS_STAGE_X + $TETRIS_STAGE_BORDERSIZE + $j * 24
				$nY = $TETRIS_STAGE_Y + $TETRIS_STAGE_BORDERSIZE + $i * 24
				DrawBlock($hDC, $nX, $nY, $aLayout[$i][$j])
			EndIf
		Next
	Next
	For $i = $iShapeX To $iShapeX + 3
		For $j = $iShapeY To $iShapeY + 3
			If $i >= 0 And $i <= 17 And $j >= 0 And $j <= 9 Then
				If $aPosition[$i - $iShapeX][$j - $iShapeY] = 1 Then
					$nX = $TETRIS_STAGE_X + $TETRIS_STAGE_BORDERSIZE + $j * 24
					$nY = $TETRIS_STAGE_Y + $TETRIS_STAGE_BORDERSIZE + $i * 24
					DrawBlock($hDC, $nX, $nY, $iIndex)
				EndIf
			EndIf
		Next
	Next
EndFunc


Func DrawBlock($hDC, $nX, $nY, $iColorIndex)
	Local $tBlockObject, $hBlockDC
	If $iColorIndex > 0 Then
		$tBlockObject = GetBlock($hDC, $iColorIndex)
		$hBlockDC = DllStructGetData($tBlockObject, "hBlockDC")
		_WinAPI_BitBlt($hDC, $nX, $nY, 25, 25, $hBlockDC, 0, 0, $SRCCOPY)
	EndIf
EndFunc


Func DrawPromptAreaShape($hDC, $iIndex)
	Local $nShapeWidth, $nShapeHeight, $nX, $nY
	$nShapeWidth = 0
	$nShapeHeight = 0
	Select
		Case $iIndex = 1
			$nShapeWidth = 49
			$nShapeHeight = 49
		Case $iIndex = 2
			$nShapeWidth = 97
			$nShapeHeight = 25
		Case $iIndex = 3
			$nShapeWidth = 73
			$nShapeHeight = 49
		Case $iIndex = 4
			$nShapeWidth = 73
			$nShapeHeight = 49
		Case $iIndex = 5
			$nShapeWidth = 73
			$nShapeHeight = 49
		Case $iIndex = 6
			$nShapeWidth = 73
			$nShapeHeight = 49
		Case $iIndex = 7
			$nShapeWidth = 73
			$nShapeHeight = 49
	EndSelect
	If $nShapeWidth > 0 And $nShapeHeight > 0 Then
		$nX = $TETRIS_PROMPTAREA_X + Round(($TETRIS_PROMPTAREA_WIDTH - $nShapeWidth) / 2, 0)
		$nY = $TETRIS_PROMPTAREA_Y + Round(($TETRIS_PROMPTAREA_HEIGHT - $nShapeHeight) / 2, 0)
		DrawShape($hDC, $nX, $nY, $iIndex)
	EndIf
EndFunc


Func DrawShape($hDC, $nX, $nY, $iIndex)
	Select
		Case $iIndex = 1
			DrawBlock($hDC, $nX, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX, $nY + 24, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY + 24, $iIndex)
		Case $iIndex = 2
			DrawBlock($hDC, $nX, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY, $iIndex)
			DrawBlock($hDC, $nX + 72, $nY, $iIndex)
		Case $iIndex = 3
			DrawBlock($hDC, $nX, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY, $iIndex)
			DrawBlock($hDC, $nX, $nY + 24, $iIndex)
		Case $iIndex = 4
			DrawBlock($hDC, $nX, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY + 24, $iIndex)
		Case $iIndex = 5
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY, $iIndex)
			DrawBlock($hDC, $nX, $nY + 24, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY + 24, $iIndex)
		Case $iIndex = 6
			DrawBlock($hDC, $nX, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY + 24, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY + 24, $iIndex)
		Case $iIndex = 7
			DrawBlock($hDC, $nX, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY, $iIndex)
			DrawBlock($hDC, $nX + 48, $nY, $iIndex)
			DrawBlock($hDC, $nX + 24, $nY + 24, $iIndex)
	EndSelect
EndFunc


Func GetBlock($hDC, $iColorIndex)
	Local $tBlockObject, $iIndex, $hBlockDC, $hBlockBitmap, $hOldBlockBitmap, $hPen, $hOldPen, _
			$hBrush, $hOldBrush, $sRect, $tRect, $i, $sBlockObject
	#comments-start
		1--ɫ
		2--ɫ
		3-L-ɫ
		4-L-ɫ
		5--ǳɫ
		6--ɫ
		7-T-ɫ
	#comments-end
	$iIndex = $iColorIndex - 1
	$tBlockObject = $aBlockObjects[$iIndex]
	If IsBool($tBlockObject) = 0 Then
		Return $tBlockObject
	EndIf
	$hBlockDC = _WinAPI_CreateCompatibleDC($hDC)
	$hBlockBitmap = _WinAPI_CreateCompatibleBitmap($hDC, 25, 25)
	$hOldBlockBitmap = _WinAPI_SelectObject($hBlockDC, $hBlockBitmap)
	_WinAPI_SetBkMode($hBlockDC, $TRANSPARENT)
	$hPen = _WinAPI_CreatePen($PS_SOLID, 0, $TETRIS_BLOCK_FILLCOLORS[$iIndex][0])
	$hOldPen = _WinAPI_SelectObject($hBlockDC, $hPen)
	$hBrush = _WinAPI_CreateSolidBrush($TETRIS_BLOCK_FILLCOLORS[$iIndex][0])
	$hOldBrush = _WinAPI_SelectObject($hBlockDC, $hBrush)
	$sRect = "int left; int top; int right; int bottom"
	$tRect = DllStructCreate($sRect)
	DllStructSetData($tRect, "left", 0)
	DllStructSetData($tRect, "top", 0)
	DllStructSetData($tRect, "right", 25)
	DllStructSetData($tRect, "bottom", 25)
	_WinAPI_Rectangle($hBlockDC, $tRect)
	$hBrush = _WinAPI_SelectObject($hBlockDC, $hOldBrush)
	_WinAPI_DeleteObject($hBrush)
	$hPen = _WinAPI_SelectObject($hBlockDC, $hOldPen)
	_WinAPI_DeleteObject($hPen)
	$hPen = _WinAPI_CreatePen($PS_SOLID, 0, $TETRIS_BLOCK_FILLCOLORS[$iIndex][7])
	$hOldPen = _WinAPI_SelectObject($hBlockDC, $hPen)
	$hBrush = _WinAPI_CreateSolidBrush($TETRIS_BLOCK_FILLCOLORS[$iIndex][7])
	$hOldBrush = _WinAPI_SelectObject($hBlockDC, $hBrush)
	DllStructSetData($tRect, "left", 5)
	DllStructSetData($tRect, "top", 4)
	DllStructSetData($tRect, "right", 21)
	DllStructSetData($tRect, "bottom", 20)
	_WinAPI_Rectangle($hBlockDC, $tRect)
	$hBrush = _WinAPI_SelectObject($hBlockDC, $hOldBrush)
	_WinAPI_DeleteObject($hBrush)
	$hPen = _WinAPI_SelectObject($hBlockDC, $hOldPen)
	_WinAPI_DeleteObject($hPen)
	For $i = 1 To 3
		$hPen = _WinAPI_CreatePen($PS_SOLID, 1, $TETRIS_BLOCK_FILLCOLORS[$iIndex][$i])
		$hOldPen = _WinAPI_SelectObject($hBlockDC, $hPen)
		_WinAPI_MoveTo($hBlockDC, $i + 1, $i + 1)
		_WinAPI_LineTo($hBlockDC, $i + 1, 24 - $i)
		_WinAPI_MoveTo($hBlockDC, $i + 2, 23 - $i)
		_WinAPI_LineTo($hBlockDC, 24 - $i, 23 - $i)
		$hPen = _WinAPI_SelectObject($hBlockDC, $hOldPen)
		_WinAPI_DeleteObject($hPen)
		$hPen = _WinAPI_CreatePen($PS_SOLID, 1, $TETRIS_BLOCK_FILLCOLORS[$iIndex][$i + 3])
		$hOldPen = _WinAPI_SelectObject($hBlockDC, $hPen)
		_WinAPI_MoveTo($hBlockDC, $i + 1, $i)
		_WinAPI_LineTo($hBlockDC, 25 - $i, $i)
		_WinAPI_MoveTo($hBlockDC, 24 - $i, $i + 1)
		_WinAPI_LineTo($hBlockDC, 24 - $i, 24 - $i)
		$hPen = _WinAPI_SelectObject($hBlockDC, $hOldPen)
		_WinAPI_DeleteObject($hPen)
	Next
	$sBlockObject = "int hBlockDC; int hBlockBitmap; int hOldBlockBitmap"
	$tBlockObject = DllStructCreate($sBlockObject)
	DllStructSetData($tBlockObject, "hBlockDC", $hBlockDC)
	DllStructSetData($tBlockObject, "hBlockBitmap", $hBlockBitmap)
	DllStructSetData($tBlockObject, "hOldBlockBitmap", $hOldBlockBitmap)
	$aBlockObjects[$iIndex] = $tBlockObject
	Return $tBlockObject
EndFunc


Func DrawScoreText($hDC, $iSeconds, $iRowCount, $iScore)
	Local $hFont, $hOldFont, $sRect, $tRect, $sTime
	$hFont = _WinAPI_CreateFont(_WinAPI_GetDeviceCaps($hDC, 90) * 16 / -72, 0, 0, 0, 700)
	$hOldFont = _WinAPI_SelectObject($hDC, $hFont)
	_WinAPI_SetBkMode($hDC, $TRANSPARENT)
	_WinAPI_SetTextColor($hDC, 0x7D5E4F)
	$sRect = "int left; int top; int right; int bottom"
	$tRect = DllStructCreate($sRect)
	DllStructSetData($tRect, "left", $TETRIS_SCOREAREA_X + 16)
	DllStructSetData($tRect, "top", $TETRIS_SCOREAREA_Y + 20)
	DllStructSetData($tRect, "right", $TETRIS_SCOREAREA_X + 70)
	DllStructSetData($tRect, "bottom", $TETRIS_SCOREAREA_Y + 52)
	_WinAPI_DrawText($hDC, "ʱ", $tRect, BitOR($DT_LEFT, $DT_VCENTER, $DT_SINGLELINE, $DT_NOCLIP))
	DllStructSetData($tRect, "left", $TETRIS_SCOREAREA_X + 16)
	DllStructSetData($tRect, "top", $TETRIS_SCOREAREA_Y + 52)
	DllStructSetData($tRect, "right", $TETRIS_SCOREAREA_X + 70)
	DllStructSetData($tRect, "bottom", $TETRIS_SCOREAREA_Y + 84)
	_WinAPI_DrawText($hDC, "", $tRect, BitOR($DT_LEFT, $DT_VCENTER, $DT_SINGLELINE, $DT_NOCLIP))
	DllStructSetData($tRect, "left", $TETRIS_SCOREAREA_X + 16)
	DllStructSetData($tRect, "top", $TETRIS_SCOREAREA_Y + 84)
	DllStructSetData($tRect, "right", $TETRIS_SCOREAREA_X + 70)
	DllStructSetData($tRect, "bottom", $TETRIS_SCOREAREA_Y + 116)
	_WinAPI_DrawText($hDC, "÷", $tRect, BitOR($DT_LEFT, $DT_VCENTER, $DT_SINGLELINE, $DT_NOCLIP))
	$sTime = CalcTimeCost($iSeconds)
	DllStructSetData($tRect, "left", $TETRIS_SCOREAREA_X + 70)
	DllStructSetData($tRect, "top", $TETRIS_SCOREAREA_Y + 20)
	DllStructSetData($tRect, "right", $TETRIS_SCOREAREA_X + 185)
	DllStructSetData($tRect, "bottom", $TETRIS_SCOREAREA_Y + 52)
	_WinAPI_DrawText($hDC, $sTime, $tRect, BitOR($DT_RIGHT, $DT_VCENTER, $DT_SINGLELINE))
	DllStructSetData($tRect, "left", $TETRIS_SCOREAREA_X + 70)
	DllStructSetData($tRect, "top", $TETRIS_SCOREAREA_Y + 52)
	DllStructSetData($tRect, "right", $TETRIS_SCOREAREA_X + 185)
	DllStructSetData($tRect, "bottom", $TETRIS_SCOREAREA_Y + 84)
	_WinAPI_DrawText($hDC, String($iRowCount), $tRect, BitOR($DT_RIGHT, $DT_VCENTER, $DT_SINGLELINE))
	DllStructSetData($tRect, "left", $TETRIS_SCOREAREA_X + 70)
	DllStructSetData($tRect, "top", $TETRIS_SCOREAREA_Y + 84)
	DllStructSetData($tRect, "right", $TETRIS_SCOREAREA_X + 185)
	DllStructSetData($tRect, "bottom", $TETRIS_SCOREAREA_Y + 116)
	_WinAPI_DrawText($hDC, String($iScore), $tRect, BitOR($DT_RIGHT, $DT_VCENTER, $DT_SINGLELINE))
EndFunc


Func DeleteObjects()
	DeleteBackgroundObjects()
	DeleteBlockObjects()
EndFunc


Func DeleteBackgroundObjects()
	If IsBool($aBackgroundObjects[0]) = 0 Then
		$aBackgroundObjects[1] = _WinAPI_SelectObject($aBackgroundObjects[0], $aBackgroundObjects[2])
		_WinAPI_DeleteObject($aBackgroundObjects[1])
		_WinAPI_DeleteDC($aBackgroundObjects[0])
	EndIf
EndFunc


Func DeleteBlockObjects()
	Local $i, $tBlockObject, $hBlockDC, $hBlockBitmap, $hOldBlockBitmap
	For $i = 0 To 6
		$tBlockObject = $aBlockObjects[$i]
		If IsBool($tBlockObject) = 0 Then
			$hBlockDC = DllStructGetData($tBlockObject, "hBlockDC")
			$hBlockBitmap = DllStructGetData($tBlockObject, "hBlockDC")
			$hOldBlockBitmap = DllStructGetData($tBlockObject, "hBlockDC")
			$hBlockBitmap = _WinAPI_SelectObject($hBlockDC, $hOldBlockBitmap)
			_WinAPI_DeleteObject($hBlockBitmap)
			_WinAPI_DeleteDC($hBlockDC)
		EndIf
	Next
EndFunc


Func CalcTimeCost($iSeconds)
	Local $sTime, $iMinutes
	$sTime = ""
	$iMinutes = Floor($iSeconds / 60)
	$iSeconds = Mod($iSeconds, 60)
	If $iMinutes = 0 Then
		$sTime = String($iSeconds) & ""
	Else
		If $iSeconds = 0 Then
			$sTime = String($iMinutes) & ""
		Else
			$sTime = String($iMinutes) & "" & $iSeconds & ""
		EndIf
	EndIf
	Return $sTime
EndFunc


Func _WinAPI_CreatePatternBrush($hBitmap)
	Local $aResult = DllCall("gdi32.dll", "handle", "CreatePatternBrush", "handle", $hBitmap)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc